; The language level must be set to MzScheme for this file
; to execute, since it does simple file manipulation.

; This file defines and runs solve-expressions-from-file,
; a procedure that reads expressions from a file and solves 
; them for the given variable.  It then writes the results
; out as a text file.

; It is assumed that the procedure (solver x exp) is defined
; in another file named solver.scm.

; The last statement in this file runs the entire process
; with the input coming from "x.txt" and the output going 
; to "x-solved.txt", then does it again with "y.txt" and "y-solved.txt".

(load "solver.scm")

; read, evaluate, print loop

(define (repl in out)
  (let ((x (read in))
        (exp (read in)))
    (if (not (eof-object? exp))
        (begin 
          (display "Solve  " out)
          (write exp out)
          (display " for " out)
          (display x out)
          (newline out)
          (display "Result " out)
          (display (solver x exp) out)
          (newline out)
          (newline out)
          
          (repl in out)
          ))))

(define (solve-expressions-from-file file-root)
  (let ((input-name (string-append file-root ".txt"))
        (output-name (string-append file-root "-solved.txt")))
    
    (if (file-exists? output-name)
        (delete-file output-name))
    (let 
        ((port-input (open-input-file input-name))
         (port-output (open-output-file output-name)))
      (repl port-input port-output)
      (close-input-port port-input)
      (close-output-port port-output))))

(solve-expressions-from-file "x")
(solve-expressions-from-file "y")
